-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local lastX = 0;
local lastY = 0;

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
--                G  L  O  B  A  L    F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to initialise the Locator frame when it is loaded
--
function NigglesLocatorOnLoad(frame)
  -- Register the frame for drag operations
  frame:RegisterForDrag("LeftButton");

  -- Show/Hide the frame, based on the user's settings
  if (NigglesDBC.LocatorShow == true) then
    NigglesLocatorShow(true);
  end

  return;
end

--
-- Function to toggle the displaying of the Locator frame
--
function NigglesLocatorShow(show)
  -- Show/Hide the Locator frame
  if (show) then
    if (show == true) then
      NigglesLocator:Show();
    else
      NigglesLocator:Hide();
    end
  else
    if (NigglesLocator:IsShown()) then
      NigglesLocator:Hide();
    else
      NigglesLocator:Show();
    end
    PlaySound("igMainMenuOptionCheckBoxOn");
  end

  -- Create or destroy a timer to update the Locator
  if (NigglesLocator:IsShown()) then
    NigglesTimerCreate("Locator", NigglesLocatorUpdate, nil, nil, 0.1, true);
  else
    NigglesTimerDestroy("Locator");
  end

  return;
end

--
-- Function to update the coordinates displayed in the Locator frame
--
function NigglesLocatorUpdate()
  -- Local Variables
  local posX;
  local posY;

  -- Get the player's current position
  posX, posY = GetPlayerMapPosition("player");
  poxX = math.floor(posX*1000)/10;
  poxX = math.floor(posY*1000)/10;

  -- Update the Locator's X position, if required
  if (posX ~= lastX) then
    _G["NigglesLocatorX"]:SetFormattedText("%4.4s,", posX*100);
    lastX = posX;
  end

  -- Update the Locator's Y position, if required
  if (posY ~= lastY) then
    _G["NigglesLocatorY"]:SetFormattedText("%4.4s", posY*100);
    lastY = posY;
  end

  return;
end
